;
; DCXBIFC.ASM - DCX-AT200 BASIC Interface Subroutines
; Revision: 1.0a
; Date Last Modified: 9/15/94
; Programmer: Bruce Robinson
; Precision Micro Control Corp.
;
;  Routines for issuing commands to DCX from BASIC programs
;  Follows Quick basic calling conventions
;
	TITLE	dcx2bifc
	PUBLIC	dcxvcmd
	PUBLIC	dcxcmd
	PUBLIC	dcxrpy
;
cmdcnt	EQU	0900h
cmdbuf	EQU	0901h
rpycnt	EQU	0A00h
rpybuf	EQU	0A01h
;
dcx2bifc	SEGMENT word public 'CODE'
		ASSUME	cs:dcx2bifc
;
; DCXVCMD(boardnum,bytecnt,bufferoff,bufferseg)
;  stack:   12        10        8	   6
dcxvcmd	PROC	FAR
	push	bp
	mov	bp,sp

	push	si
	push	di
	push	ds

	mov	bx,[bp+10]	;Get byte count
	mov	ax,[bx]
	mov	dx,ax		;Save count for later
	mov	cx,ax		;Set cx for block move

	mov	bx,[bp+12]	;Get board number
	mov	ax,[bx]
	mov	ah,0D0h		;Convert to segment of board memory
	and	al,0Fh
	or	ah,al
	mov	al,0
	mov	es,ax		;Set extra segment register to DCX memory

	mov	di,cmdbuf	;Set di to command buffer of DCX

	mov	bx,[bp+8]	;Get source array address offset
	mov	si,[bx]

	mov	bx,[bp+6]	;Get source array address segment
	mov	ax,[bx]
	mov	ds,ax

				;Wait until DCX ready
wtrdy1:	mov	al,byte ptr es:[cmdcnt]
	and	al,al
	jnz	wtrdy1

	rep movsb		;Move command block to DCX

				;Set reply count to zero
	mov	byte ptr es:[rpycnt],0

				;Set command count to number of bytes
	mov	byte ptr es:[cmdcnt],dl

	pop	ds
	pop	di
	pop	si

	pop	bp
	ret	8		;remove basic parameters from stack
dcxvcmd	ENDP
;
;
; DCXCMD(boardnum,commandcnt,bufferoff,bufferseg)
;  stack:   12        10        8	   6
dcxcmd	PROC	FAR
	push	bp
	mov	bp,sp

	push	si
	push	di
	push	ds

	mov	bx,[bp+10]	;Get command count
	mov	ax,[bx]
	mov	cx,6
	mul	cx		;Calculate number of bytes in buffer
	mov	dx,ax		;Save count for later
	mov	cx,ax		;Set cx for block move

	mov	bx,[bp+12]	;Get board number
	mov	ax,[bx]
	mov	ah,0D0h		;Convert to segment of board memory
	and	al,0Fh
	or	ah,al
	mov	al,0
	mov	es,ax		;Set extra segment register to DCX memory

	mov	di,cmdbuf	;Set di to command buffer of DCX

	mov	bx,[bp+8]	;Get source array address offset
	mov	si,[bx]

	mov	bx,[bp+6]	;Get source array address segment
	mov	ax,[bx]
	mov	ds,ax

				;Wait until DCX ready
wtrdy2:	mov	al,byte ptr es:[cmdcnt]
	and	al,al
	jnz	wtrdy2

	rep movsb		;Move command block to DCX

				;Set reply count to zero
	mov	byte ptr es:[rpycnt],0

				;Set command count to number of bytes
	mov	byte ptr es:[cmdcnt],dl

	pop	ds
	pop	di
	pop	si

	pop	bp
	ret	8		;remove basic parameters from stack
dcxcmd	ENDP
;
;
;
; DCXRPY(boardnum,bufferoff,bufferseg)
;  stack:   10        8         6
dcxrpy	PROC	FAR
	push	bp
	mov	bp,sp

	push	si
	push	di
	push	ds

	mov	bx,[bp+8]	;Get destination array address offset
	mov	di,[bx]

	mov	bx,[bp+6]	;Get destination array address segment
	mov	ax,[bx]
	mov	es,ax

	mov	bx,[bp+10]	;Get board number
	mov	ax,[bx]
	mov	ah,0D0h		;Convert to segment of board memory
	and	al,0Fh
	or	ah,al
	mov	al,0
	mov	ds,ax		;Set data segment register to DCX address

	mov	si,rpybuf	;Set di to command buffer of DCX

				;Wait until DCX ready
	sub	ax,ax
wtrdy3:	mov	al,byte ptr ds:[cmdcnt]
	and	al,al
	jnz	wtrdy3
				;Get number of valid bytes
	mov	al,byte ptr ds:[rpycnt]

	mov	cx,ax		;Set repeat count

	rep movsb		;Move DCX reply block to array

	pop	ds
	pop	di
	pop	si

	pop	bp
	ret	6		;remove basic parameters from stack
dcxrpy	ENDP


dcx2bifc	ENDS

	END

