'
'DCX-AT200 BASIC Interface Include file
'
'Declare command used to access DCX
DECLARE SUB dcxvcmd (board%, count%, arrayoff%, arrayseg%)
DECLARE SUB dcxcmd (board%, count%, arrayoff%, arrayseg%)
DECLARE FUNCTION dcxrpy% (board%, arrayoff%, arrayseg%)
'
' Parameter setup command subroutines
DECLARE SUB set.acceleration.gain (board%, axis%, gain#)
DECLARE SUB aux.enc.define.home (board%, axis%)
DECLARE SUB set.baud.rate (board%, baud%)
DECLARE SUB channel.off (board%, channel%)
DECLARE SUB channel.high.true.logic (board%, channel%)
DECLARE SUB channel.in (board%, channel%)
DECLARE SUB channel.low (board%, channel%)
DECLARE SUB channel.on (board%, channel%)
DECLARE SUB channel.out (board%, channel%)
DECLARE SUB set.position.deadband (board%, axis%, deadband#)
DECLARE SUB set.deceleration.gain (board%, axis%, gain#)
DECLARE SUB define.home (board%, axis%, position#)
DECLARE SUB direction (board%, axis%, dir%)
DECLARE SUB deceleration.set (board%, axis%, rate#)
DECLARE SUB delay.at.target (board%, axis%, period#)
DECLARE SUB full.current (board%, axis%)
DECLARE SUB amplifier.fault.input.off (board%, axis%)
DECLARE SUB amplifier.fault.input.on (board%, axis%)
DECLARE SUB set.derivative.sampling.period (board%, axis%, period%)
DECLARE SUB half.current (board%, axis%)
DECLARE SUB high.motion.limit (board%, axis%, position#)
DECLARE SUB high.speed (board%, axis%)
DECLARE SUB set.integration.limit (board%, axis%, limit#)
DECLARE SUB jog.acceleration (board%, axis%, rate#)
DECLARE SUB jog.deadband (board%, axis%, deadband#)
DECLARE SUB jog.proportional.gain (board%, axis%, gain#)
DECLARE SUB jog.offset (board%, axis%, offset#)
DECLARE SUB jog.min.velocity (board%, axis%, rate#)
DECLARE SUB motion.limits.off (board%, axis%, sel%)
DECLARE SUB low.motion.limit (board%, axis%, position#)
DECLARE SUB limit.mode (board%, axis%, mode%)
DECLARE SUB motion.limits.on (board%, axis%, sel%)
DECLARE SUB low.speed (board%, axis%)
DECLARE SUB medium.speed (board%, axis%)
DECLARE SUB set.min.velocity (board%, axis%, rate#)
DECLARE SUB set.module.output.mode (board%, axis%, sel%)
DECLARE SUB set.servo.output.phase (board%, axis%, sel%)
DECLARE SUB set.acceleration (board%, axis%, rate#)
DECLARE SUB set.derivative.gain (board%, axis%, gain#)
DECLARE SUB stop.on.error (board%, axis%, poserr#)
DECLARE SUB step.full (board%, axis%)
DECLARE SUB set.proportional.gain (board%, axis%, gain#)
DECLARE SUB step.half (board%, axis%)
DECLARE SUB set.integral.gain (board%, axis%, gain#)
DECLARE SUB set.torque (board%, axis%, torque#)
DECLARE SUB set.slave.ratio (board%, axis%, ratio#)
DECLARE SUB set.velocity (board%, axis%, rate#)
DECLARE SUB set.user.output.constant (board%, axis%, value#)
DECLARE SUB set.user.offset (board%, axis%, value#)
DECLARE SUB set.user.rate (board%, axis%, value#)
DECLARE SUB set.user.scale (board%, axis%, value#)
DECLARE SUB set.user.time (board%, value#)
DECLARE SUB set.user.zero (board%, axis%, value#)
DECLARE SUB vector.acceleration (board%, axis%, rate#)
DECLARE SUB vector.deceleration (board%, axis%, rate#)
DECLARE SUB set.velocity.gain (board%, axis%, gain#)
DECLARE SUB set.velocity.override (board%, axis%, value#)
DECLARE SUB vector.velocity (board%, axis%, rate#)
'
' Motion command subroutines
DECLARE SUB abort (board%, axis%)
DECLARE SUB aux.enc.find.index (board%, axis%)
DECLARE SUB contour.mode (board%, axis%, caxis%)
DECLARE SUB find.edge (board%, axis%, position#)
DECLARE SUB find.index (board%, axis%, position#)
DECLARE SUB go.home (board%, axis%)
DECLARE SUB gain.mode (board%, axis%)
DECLARE SUB go.motion (board%, axis%)
DECLARE SUB home (board%, axis%)
DECLARE SUB index.arm (board%, axis%, position#)
DECLARE SUB learn.position (board%, axis%, index%)
DECLARE SUB learn.target (board%, axis%, index%)
DECLARE SUB move.absolute (board%, axis%, position#)
DECLARE SUB motor.off (board%, axis%)
DECLARE SUB motor.on (board%, axis%)
DECLARE SUB move.to.point (board%, axis%, index%)
DECLARE SUB move.relative (board%, axis%, distance#)
DECLARE SUB no.synchronization (board%, axis%)
DECLARE SUB position.mode (board%, axis%)
DECLARE SUB profile.s.curve (board%, axis%)
DECLARE SUB profile.trapezoidal (board%, axis%)
DECLARE SUB torque.mode (board%, axis%)
DECLARE SUB set.master (board%, axis%, maxis%)
DECLARE SUB synchronization.on (board%, axis%)
DECLARE SUB stop.motion (board%, axis%)
DECLARE SUB velocity.mode (board%, axis%)
'
' Reporting command subroutines
DECLARE SUB tell.aux.enc.pos (board%, axis%)
DECLARE SUB tell.aux.enc.idx (board%, axis%)
DECLARE SUB tell.analog (board%, channel%)
DECLARE SUB tell.breakpoint (board%, axis%)
DECLARE SUB tell.channel (board%, channel%)
DECLARE SUB tell.derivative.gain (board%, axis%)
DECLARE SUB tell.following.error (board%, axis%)
DECLARE SUB tell.proportional.gain (board%, axis%)
DECLARE SUB tell.integral.gain (board%, axis%)
DECLARE SUB tell.velocity.constant (board%, axis%)
DECLARE SUB tell.integration.limit (board%, axis%)
DECLARE SUB tell.optimal (board%, axis%)
DECLARE SUB tell.position (board%, axis%)
DECLARE SUB tell.torque (board%, axis%)
DECLARE SUB tell.status (board%, axis%)
DECLARE SUB tell.target (board%, axis%)
DECLARE SUB tell.velocity (board%, axis%)
DECLARE SUB tell.contouring.count (board%, axis%)
DECLARE SUB tell.index (board%, axis%)
'
' Register command subroutines
DECLARE SUB accumlator.load.long(board%, value&)
DECLARE SUB accumlator.load.float(board%, value!)
DECLARE SUB accumlator.load.double(board%, value#)
DECLARE SUB copy.acc.to.reg(board%, register%)
DECLARE SUB read.byte(board%, axis%, location&)
DECLARE SUB read.double(board%, axis%, location&)
DECLARE SUB read.long(board%, axis%, location&)
DECLARE SUB read.float(board%, axis%, location&)
DECLARE SUB read.word(board%, axis%, location&)
DECLARE SUB copy.reg.to.acc(board%, register%)
DECLARE SUB tell.register(board%, register%)
DECLARE SUB write.byte(board%, axis%, location&)
DECLARE SUB write.double(board%, axis%, location&)
DECLARE SUB write.long(board%, axis%, location&)
DECLARE SUB write.float(board%, axis%, location&)
DECLARE SUB write.word(board%, axis%, location&)
'
' Macro command subroutines
DECLARE SUB generate.task (board%, macro%)
DECLARE SUB macro.call (board%, macro%)
DECLARE SUB macro.jump (board%, macro%)
'
' Sequence command subroutines
DECLARE SUB interrupt.on.position (board%, axis%, position#)
DECLARE SUB interrupt.on.relative (board%, axis%, distance#)
DECLARE SUB wait.time (board%,period#)
DECLARE SUB wait.for.edge (board%, axis%, level%)
DECLARE SUB wait.for.channel.off (board%, channel%)
DECLARE SUB wait.for.index (board%, axis%)
DECLARE SUB wait.for.channel.on (board%, channel%)
DECLARE SUB wait.for.position (board%, axis%, position#)
DECLARE SUB wait.for.relative (board%, axis%, distance#)
DECLARE SUB wait.for.stop (board%, axis%, period#)
DECLARE SUB wait.for.target (board%, axis%, period#)
'
' Functions for issuing reporting commands to board and returning values
DECLARE FUNCTION get.aux.enc.pos& (board%, axis%)
DECLARE FUNCTION get.aux.enc.idx& (board%, axis%)
DECLARE FUNCTION get.analog& (board%, channel%)
DECLARE FUNCTION get.breakpoint# (board%, axis%)
DECLARE FUNCTION get.channel& (board%, channel%)
DECLARE FUNCTION get.derivative.gain# (board%, axis%)
DECLARE FUNCTION get.following.error# (board%, axis%)
DECLARE FUNCTION get.proportional.gain# (board%, axis%)
DECLARE FUNCTION get.integral.gain# (board%, axis%)
DECLARE FUNCTION get.velocity.constant# (board%, axis%)
DECLARE FUNCTION get.integration.limit# (board%, axis%)
DECLARE FUNCTION get.optimal# (board%, axis%)
DECLARE FUNCTION get.position# (board%, axis%)
DECLARE FUNCTION get.register.long& (board%, register%)
DECLARE FUNCTION get.register.float! (board%, register%)
DECLARE FUNCTION get.register.double# (board%, register%)
DECLARE FUNCTION get.torque# (board%, axis%)
DECLARE FUNCTION get.status& (board%, axis%)
DECLARE FUNCTION get.target# (board%, axis%)
DECLARE FUNCTION get.velocity# (board%, axis%)
DECLARE FUNCTION get.contouring.count& (board%, axis%)
DECLARE FUNCTION get.index# (board%, axis%)
'
' DCX dual port memory equates.
CONST DCXSEG = &HD000           ' Memory sement where DCX dual port ram is.
CONST DATAOUT = &H804           ' Memory offset for data out mailbox.
CONST DATAIN = &H800            ' Memory offset for data in mailbox.
CONST CMDSTAT = &H808           ' Memory offset for command status.
CONST MODLOC = &H80A            ' Memory offset for motor module locations.
CONST MODTYP = &H812            ' Memory offset for array of module types.
CONST CMDCNT = &H900            ' Memory offset for command count.
CONST CMDBLK = &H901            ' Memory offset for command block.
CONST RPYCNT = &HA00            ' Memory offset for reply count.
CONST RPYBLK = &HA01            ' Memory offset for reply block.
'
' Module ID codes
CONST MC200 = 0                 ' Advanced Servo
CONST MC260 = 1                 ' Advanced Stepper
CONST MC100 = 5                 ' Servo with analog signal output
CONST MC110 = 4                 ' Servo with motor drive output
CONST MC120 = 4                 ' Servo with PWM output
CONST MC150 = 6                 ' Stepper motor
CONST MC160 = 7                 ' Stepper motor with encoder
CONST MC400 = 8                 ' Digital I/O module
CONST MC500 = 12                ' Analog I/O module
CONST MF310 = 9                 ' GPIB interface
CONST MF300 = 10                ' RS232 interface
CONST NOMOD = 15                ' No module installed
'
' Axis values for parameters to dcxcmd() function.
CONST AXIS1 = &H100
CONST AXIS2 = &H200
CONST AXIS3 = &H300
CONST AXIS4 = &H400
CONST AXIS5 = &H500
CONST AXIS6 = &H600
'
' Modifier flags for axis bytes in the dcxcmd() and dcxvcmd() function
'  parameters
CONST INDPARFLAG = &H8000               ' Indirect parameter flag
CONST NOPARFLAG = &H6000                ' No parameter flag
CONST FLTPARFLAG = &H4000               ' Float parameter flag
CONST DBLPARFLAG = &H2000               ' Double parameter flag
'
' Number of bytes in binary DCX commands (depends on type of parameter)
CONST CMDSZ = 2                                                 ' no parameter
CONST LNGCMDSZ = 6                                      ' with long parameter
CONST FLTCMDSZ = 6                                      ' with float parameter
CONST DBLCMDSZ = 10                             ' with double parameter
'
' Parameter values for Tell commands
CONST LNGRPY = 0                ' Tell command will have long integer reply format
CONST DBLRPY = 1                ' Tell command will have double reply format
CONST FLTRPY = 2                                ' Tell command will have float reply format
'
' Motor data offsets
CONST STAT = &H0                ' Motor status
CONST POSCNT = &H4              ' Position Count (encoder or steps)
CONST OPTCNT = &H8              ' Optimal Count (encoder or steps)
CONST IDXCNT = &HC              ' Index Count (encoder or steps)
CONST AUXSTAT = &H10            ' Auxiliary Motor Status
CONST POSITION = &H14           ' Position in user units
CONST TARGET = &H1C             ' Tareget in user units
CONST OPTIMAL = &H24            ' Optimal position in user units
CONST BRKPOS = &H2C             ' Break position in user units
CONST DEADBAND = &H34           ' Deadband in user units
CONST MAXERROR = &H3C           ' Maximum following error in user units
CONST LOLIMIT = &H44            ' Low limit of movement in user units
CONST HILIMIT = &H4C            ' High limit of movement in user units
CONST SCALE = &H54              ' User Scale
CONST ZERO = &H5C               ' User Zero
CONST OFFSET = &H64             ' User Offset
CONST RATE = &H6C               ' User Rate conversion
CONST OUTCONST = &H74           ' User output Konstant
CONST PGMVEL = &H7C             ' Programmed velocity in user units
CONST PGMACC = &H84             ' Programmed acceleration in user units
CONST PGMDEC = &H8C             ' Programmed deceleration in user units
CONST MINVEL = &H94             ' Minimum velocity in user units
CONST CURVEL = &H9C             ' Current velocity in user units
CONST KVEL = &HA4               ' Velocity gain, in user distance units
CONST KACC = &HA8               ' Acceleration gain, in user distance units
CONST KDEC = &HAC               ' Deceleration gain, in user distance units
CONST VELOVRD = &HB0            ' Velocity override
CONST MAXTRQ = &HB4             ' Torque limit
CONST KPOS = &HB8               ' Proportional gain
CONST KDER = &HBC               ' Derivative gain
CONST KINT = &HC0               ' Integral gain
CONST ILIM = &HC4               ' Integration limit
CONST ADCIN1 = &HC8             ' Analog input 1 on module
CONST ADCIN2 = &HCC             ' Analog input 2 on module
CONST JGAIN = &HD0              ' Jog proportional Gain
CONST JOFFSET = &HD4            ' Jog Offset
CONST JBAND = &HD8              ' Jog deadBand
CONST JOGACC = &HDC             ' Jog acceleration in user units
CONST JOGMINVEL = &HE4          ' Jog minimum velocity in user units
CONST WAITSTOP = &HEC           ' Wait stopped timer
CONST WAITTRGT = &HEE           ' Wait target timer
CONST SFREQ = &HF0              ' Sampling frequency
CONST MASTER = &HF2             ' Set to axis that is master
CONST MODST = &HF4              ' Module status
CONST AXISNUM = &HF6            ' Axis number 1-6
CONST MODULE = &HF8             ' Module position
CONST MODTYPE = &HFA            ' Module type
'
' Motor status bit definitions
CONST MTRBSY& = &H1      ' BUSY (SERVO PARAMETERS BEING UPDATAED)
CONST MTRON& = &H2       ' MOTOR ON
CONST MTRAT& = &H4       ' AT TARGET
CONST MTRTC& = &H8       ' TRAJECTORY COMPLETE
CONST MTRDI& = &H10      ' DIRECTION ( 0 = POSITIVE, 1 = NEGATIVE )
CONST MTRJOG& = &H20     ' JOGGING IS ENABLED
CONST MTRHMD& = &H40     ' MOTOR HOMED
CONST MTRERR& = &H80     ' MOTOR ERROR
CONST MTRLFI& = &H100    ' LOOK FOR INDEX
CONST MTRLFE& = &H200    ' LOOK FOR EDGE
CONST MTRBRK& = &H1000   ' BREAKPOINT REACHED
CONST MTREFE& = &H2000   ' EXCEEDED MAXIMUM FOLLOWING ERROR
CONST MTRAFE& = &H4000   ' AMPLIFIER FAULT ENABLED
CONST MTRAFT& = &H8000   ' AMPLIFIER FAULT TRIPPED
CONST MTRLPE& = &H10000          ' HARD LIMIT POSITIVE ENABLED
CONST MTRLPT& = &H20000          ' HARD LIMIT POSITIVE TRIPPED
CONST MTRLNE& = &H40000          ' HARD LIMIT NEGATIVE ENABLED
CONST MTRLNT& = &H80000          ' HARD LIMIT NEGATIVE TRIPPED
CONST MTRLHE& = &H100000         ' SOFT POSITION LIMIT HIGH ENABLED
CONST MTRLHT& = &H200000         ' SOFT POSITION LIMIT HIGH TRIPPED
CONST MTRLLE& = &H400000         ' SOFT POSITION LIMIT LOW ENABLED
CONST MTRLLT& = &H800000         ' SOFT POSITION LIMIT LOW TRIPPED
CONST MTRIDX& = &H1000000                ' ENCODER INDEX / STEPPER HOME
CONST MTRCRS& = &H2000000                ' COARSE HOME
CONST MTREE& = &H4000000                 ' AMPLIFIER FAULT
CONST MTRRSV& = &H8000000                ' AUXILIARY ENCODER INDEX
CONST MTRLMR& = &H10000000       ' LIMIT POSITIVE INPUT ACTIVE
CONST MTRLML& = &H20000000       ' LIMIT NEGATIVE INPUT ACTIVE
CONST MTRJGR& = &H40000000       ' USER INPUT 1
CONST MTRJGL& = &H80000000       ' USER INPUT 2
'
' DCX Command Codes
' Parameter Setup Commands
CONST AG = 226                          ' set Acceleration Feed-Forward Gain
CONST AH = 234                          ' Auxiliary encoder define Home
CONST BR = 30                           ' Baud Rate
CONST CF = 31                           ' Channel ofF
CONST CH = 66                           ' Channel High true
CONST CI = 32                           ' Channel In
CONST CL = 67                           ' Channel Low true
CONST CN = 33                           ' channel oN
CONST CT = 34                           ' Channel ouT
CONST DB = 118                          ' set DeadBand
CONST DG = 227                          ' set Deceleration Feed-Forward Gain
CONST DH = 35                           ' Define Home
CONST DI = 36                           ' DIrection
CONST DS = 117                          ' Deceleration Set
CONST DT = 197                          ' at Target Delay
CONST EF = 37                           ' Echo ofF
CONST EN = 38                           ' Echo oN
CONST FC = 64                           ' Full Current
CONST FF = 51                           ' Fail input ofF
CONST FFN = 50                           ' Fail input oN
CONST FR = 39                           ' set derivative sampling period
CONST HC = 65                           ' Half Current
CONST HF = 48                           ' RS232 module Handshake ofF
CONST HL = 211                          ' set motion High Limit
CONST HN = 49                           ' RS232 module Handshake oN
CONST HS = 232                          ' High Speed
CONST IL = 40                           ' set Integration Limit
CONST JA = 56                           ' Jog Acceleration
CONST JB = 223                          ' Jog Deadband
CONST JF = 58                           ' Jog ofF
CONST JG = 220                          ' Jog Gain
CONST JN = 57                           ' Jog oN
CONST JO = 222                          ' Jog Offset
CONST JV = 55                           ' Jog Velocity
CONST LF = 54                           ' Limit switch ofF
CONST LL = 210                          ' set motion Low Limit
CONST LM = 52                           ' Limit switch Mode
CONST LN = 53                           ' Limit switch oN
CONST LS = 230                          ' Low Speed
CONST MS = 231                          ' Medium Speed
CONST MV = 196                          ' set Minimum Velocity
CONST OM = 216                          ' set Output Mode
CONST PC = 128                          ' Prompt Character
CONST PH = 115                          ' Set Phasing
CONST PS = 238                          ' Profile S-curve
CONST PT = 239                          ' Profile Trapezoidal
CONST RT = 42                           ' ReseT system
CONST SA = 43                           ' Set Acceleration
CONST SD = 44                           ' Set Derivative gain
CONST SE = 25                           ' Stop on Error
CONST SF = 62                           ' Step Full
CONST SG = 45                           ' Set Gain
CONST SH = 63                           ' Step Half
CONST SI = 46                           ' Set Integral gain
CONST SQ = 116                          ' Set torque
CONST SS = 29                           ' Set Slave ratio
CONST SV = 47                           ' Set Velocity
CONST UK = 215                          ' set User output Konstant
CONST UO = 179                          ' set User Offset
CONST UR = 177                          ' set User Rate conversion
CONST US = 175                          ' set User Scale
CONST UT = 178                          ' set User Time conversion
CONST UZ = 176                          ' set User Zero
CONST VA = 173                          ' Vector Acceleration
CONST VD = 174                          ' Vector Deceleration
CONST VG = 119                          ' set Velocity Gain
CONST VO = 224                          ' set Velocity Override
CONST VV = 172                          ' Vector Velocity
CONST XN = 125                          ' Set XON character
CONST XF = 126                          ' Set XOF character
'
' Motion Commands
CONST AB = 10                           ' ABort
CONST AF = 235                          ' Auxiliary encoder Find index
CONST CA = 180                          ' arc Center Absolute
CONST CD = 193                          ' Contour Distance
CONST CM = 27                           ' set Contouring Mode
CONST CP = 192                          ' Contour Path
CONST CR = 181                          ' arc Center Relative
CONST FE = 11                           ' Find Edge
CONST FI = 12                           ' Find Index
CONST GH = 13                           ' Go Home
CONST GM = 8                            ' Gain Mode
CONST GGO = 14                           ' GO
CONST HO = 15                           ' HOme
CONST IA = 93                           ' Index Arm
CONST LP = 112                          ' Learn Position
CONST LT = 113                          ' Learn Target
CONST MA = 16                           ' Move Absolute
CONST MF = 17                           ' Motor ofF
CONST MN = 19                           ' Motor oN
CONST MP = 20                           ' Move to Point
CONST MR = 21                           ' Move Relative
CONST NS = 171                          ' No Syncronization
CONST PM = 23                           ' Position Mode
CONST QM = 9                            ' Torque Mode
CONST SM = 26                           ' Set Master
CONST SN = 170                          ' Syncroniztion oN
CONST ST = 22                           ' STop
CONST VM = 24                           ' Velocity Mode
'
' Reporting Commands
CONST AT = 233                          ' Auxiliary encoder Tell position
CONST AZ = 236                          ' Auxiliary encoder tell Index
CONST CC = 70                           ' Current Count
CONST CS = 71                           ' CheckSum
CONST HE = 72                           ' HElp
CONST TA = 73                           ' Tell A/d
CONST TB = 91                           ' Tell Breakpoint Position
CONST TC = 74                           ' Tell Channel
CONST TD = 75                           ' Tell Derivative Gain
CONST TF = 77                           ' Tell Following error
CONST TG = 78                           ' Tell Position Gain
CONST TI = 79                           ' Tell Integral Gain
CONST TK = 92                           ' Tell velocity Konstant
CONST TL = 80                           ' Tell Integration Limit
CONST TTO = 89                          ' Tell Optimal
CONST TP = 82                           ' Tell Position
CONST TQ = 209                          ' Tell torQue
CONST TS = 83                           ' Tell Status
CONST TT = 84                           ' Tell Target
CONST TV = 85                           ' Tell Velocity
CONST TX = 88                           ' Tell Contouring Count
CONST TZ = 90                           ' Tell Index
CONST VE = 86                           ' tell VErsion
'	
' Register Commands
CONST AA = 133                          ' Accumulator Add
CONST AC = 140                          ' Accumulator Complement
CONST AD = 136                          ' Accumulator Divide
CONST AE = 143                          ' Accumulator Eor
CONST AL = 130                          ' Accumulator Load with constant
CONST AM = 135                          ' Accumulator Multiply
CONST AN = 141                          ' Accumulator aNd
CONST AO = 142                          ' Accumulator Or
CONST AR = 132                          ' copy Accumulator to Register
CONST AAS = 134                          ' Accumulator Subtract
CONST AV = 139                          ' Accumulator eValuate
CONST GA = 248                          ' Get Analog input reading into accumulator
CONST GX = 247                          ' Get auXiliary encoder position into accumulator
CONST OA = 249                          ' Output Analog value from accumulator
CONST RA = 131                          ' copy Register to Accumulator
CONST RB = 150                          ' Read accumulator Byte
CONST RD = 147                          ' Read accumulator double (64 bit floating point)
CONST RL = 152                          ' Read accumulator Long
CONST RV = 146                          ' Read accumulator float (32 bit floating point)
CONST RW = 151                          ' Read accumulator Word
CONST SL = 144                          ' accumulator Shift Left
CONST SR = 145                          ' accumulator Shift Right
CONST TR = 87                           ' Tell Register
CONST WB = 153                          ' Write accumulator Byte
CONST WD = 149                          ' Write accumulator double (64 bit floating point)
CONST WL = 155                          ' Write accumulator Long
CONST WV = 148                          ' Write accumulator float (32 bit floating point)
CONST WW = 154                          ' Write accumulator Word
'
' Macro Commands
CONST ET = 251                          ' Escape Task
CONST GT = 250                          ' Generate Task
CONST MC = 2                                    ' Macro Call Command
CONST MD = 3                                    ' Macro Definition
CONST MJ = 5                                    ' Macro Jump Command
CONST RM = 4                                    ' Reset Macros
CONST TM = 81                           ' Tell Macros
'
' Sequence Commands
CONST DF = 107                          ' Do if channel ofF
CONST DN = 106                          ' Do if channel oN
CONST IB = 165                          ' If accumulator Below (less then)
CONST IC = 161                          ' If bit Clear in accumulator
CONST IE = 162                          ' If accumulator Equal
CONST IFF = 109                         ' If channel ofF then, else skip two
CONST IG = 164                          ' If accumulator Greater than
CONST INN = 108                         ' If channel oN then, else skip two
CONST IP = 96                           ' Interrupt on absolute Position
CONST IR = 97                           ' Interrupt on Relative position
CONST ISS = 160                          ' If bit Set in accumulator
CONST IU = 163                          ' If accumulator Unequal
CONST JP = 6                                    ' Jump to command absolute
CONST JR = 7                                    ' Jump to command relative
CONST RP = 100                          ' RePeat
CONST WA = 101                          ' WAit (time)
CONST WE = 102                          ' Wait Edge
CONST WF = 103                          ' Wait for Channel ofF
CONST WI = 94                           ' Wait for Index
CONST WN = 104                          ' Wait for Channel oN
CONST WP = 98                           ' Wait for absolute Position
CONST WR = 99                           ' Wait for Relative position
CONST WS = 105                          ' Wait for Stop
CONST WT = 198                          ' Wait for Target
'
' Miscellaneous Commands
CONST BK = 121                          ' Break
CONST DM = 60                           ' Decimal Mode
CONST HM = 61                           ' Hex Mode
CONST NO = 120                          ' No Operation
'
' Contour Path Modes
CONST USERDEF = 0
CONST LINEAR = 1
CONST ARCCW = 2
CONST ARCCCW = 3
'
'DCX commands with no parameter has the following format
TYPE CMDFMT
    axcmd AS INTEGER        'byte 1 specifies command, byte 2 specifies axis
END TYPE
'
'DCX commands with a long parameter has the following format
TYPE CMDLNGFMT
    axcmd AS INTEGER        'byte 1 specifies command, byte 2 specifies axis
    param AS LONG           'bytes 3 through 6 contain long parameter
END TYPE
'
'DCX commands with a single parameter has the following format
TYPE CMDFLTFMT
    axcmd AS INTEGER        'byte 1 specifies command, byte 2 specifies axis
    param AS SINGLE         'bytes 3 through 6 contain single parameter
END TYPE
'
'DCX commands with a double parameter has the following format
TYPE CMDDBLFMT
    axcmd AS INTEGER        'byte 1 specifies command, byte 2 specifies axis
    param AS DOUBLE         'bytes 3 through 10 contain double parameter
END TYPE
'
'DCX long replies have the following format
TYPE RPYLNGFMT
    axcmd AS INTEGER        'bytes 1 & 2 specify axis
    value AS LONG           'bytes 3 through 6 contain long value
END TYPE
'
'DCX single replies have the following format
TYPE RPYFLTFMT
    axcmd AS INTEGER        'bytes 1 & 2 specify axis
    value AS SINGLE         'bytes 3 through 6 contain single value
END TYPE
'
'DCX double replies have the following format
TYPE RPYDBLFMT
    axcmd AS INTEGER        'bytes 1 & 2 specify axis
    value AS DOUBLE         'bytes 3 through 10 contain double value
END TYPE
'
'Create an array for DCX commands with long parameters
DIM cmdlngbuf(0 TO 40) AS CMDLNGFMT
'
'Create an array for DCX commands with float parameters
DIM cmdfltbuf(0 TO 40) AS CMDFLTFMT
'
'Create an array for DCX commands with double parameters
DIM cmddblbuf(0 TO 40) AS CMDDBLFMT
'
'Create an array for DCX replies of type long
DIM rpylngbuf(0 TO 6) AS RPYLNGFMT
'
'Create an array for DCX replies of type float
DIM rpyfltbuf(0 TO 6) AS RPYFLTFMT
'
'Create an array for DCX replies of type double
DIM rpydblbuf(0 TO 6) AS RPYDBLFMT
'
'
'End of DCX2BINC.BAS

