/*
	DCX2CMAC.H - DCX-AT200 'C' Macros
   Copyright Precision Micro Control Corp. 1994, All rights reserved
   Revision:  (see DCX2CIFC.C)
   Date Last Modified: 9/6/94
   Programmer: Bruce Robinson

	This file contains macros for use with the DCX Series 200 'C' interface
	library. The macros in this header file can be included into the end users
	application programs.

	Revision History: DCX2CIFC.C

*/


/* Parameter setup command macros */
#define set_acceleration_gain(board,axis,gain) dcxvcmd(board,DBLCMDSZ,(axis<<8)+AG+DBLPARFLAG,(double)gain)
#define aux_enc_define_home(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+AH+NOPARFLAG)
#define set_baud_rate(board,baud) dcxvcmd(board,LNGCMDSZ,BR,(long)baud)
#define channel_off(board,channel) dcxvcmd(board,LNGCMDSZ,CF,(long)channel)
#define channel_high_true_logic(board,channel) dcxvcmd(board,LNGCMDSZ,CH,(long)channel)
#define channel_in(board,channel) dcxvcmd(board,LNGCMDSZ,CI,(long)channel)
#define channel_low(board,channel) dcxvcmd(board,LNGCMDSZ,CL,(long)channel)
#define channel_on(board,channel) dcxvcmd(board,LNGCMDSZ,CN,(long)channel)
#define channel_out(board,channel) dcxvcmd(board,LNGCMDSZ,CT,(long)channel)
#define set_position_deadband(board,axis,deadband) dcxvcmd(board,DBLCMDSZ,(axis<<8)+DB+DBLPARFLAG,(double)deadband)
#define set_deceleration_gain(board,axis,gain) dcxvcmd(board,DBLCMDSZ,(axis<<8)+DG+DBLPARFLAG,(double)gain)
#define define_home(board,axis,position) dcxvcmd(board,DBLCMDSZ,(axis<<8)+DH+DBLPARFLAG,(double)position)
#define direction(board,axis,dir) dcxvcmd(board,LNGCMDSZ,(axis<<8)+DI,(long)dir)
#define deceleration_set(board,axis,rate) dcxvcmd(board,DBLCMDSZ,(axis<<8)+DS+DBLPARFLAG,(double)rate)
#define delay_at_target(board,axis,period) dcxvcmd(board,DBLCMDSZ,(axis<<8)+DT+DBLPARFLAG,(double)period)
#define full_current(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+FC+NOPARFLAG)
#define amplifier_fault_input_off(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+FF+NOPARFLAG)
#define amplifier_fault_input_on(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+FN+NOPARFLAG)
#define set_derivative_sampling_period(board,axis,period) dcxvcmd(board,LNGCMDSZ,(axis<<8)+DI,(long)period)
#define half_current(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+HC+NOPARFLAG)
#define high_motion_limit(board,axis,position) dcxvcmd(board,DBLCMDSZ,(axis<<8)+HL+DBLPARFLAG,(double)position)
#define high_speed(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+HS+NOPARFLAG)
#define set_integration_limit(board,axis,limit) dcxvcmd(board,DBLCMDSZ,(axis<<8)+IL+DBLPARFLAG,(double)limit)
#define jog_acceleration(board,axis,rate) dcxvcmd(board,DBLCMDSZ,(axis<<8)+JA+DBLPARFLAG,(double)rate)
#define jog_deadband(board,axis,deadband) dcxvcmd(board,DBLCMDSZ,(axis<<8)+JB+DBLPARFLAG,(double)deadband)
#define jog_proportional_gain(board,axis,gain) dcxvcmd(board,DBLCMDSZ,(axis<<8)+JG+DBLPARFLAG,(double)gain)
#define jog_offset(board,axis,offset) dcxvcmd(board,DBLCMDSZ,(axis<<8)+JO+DBLPARFLAG,(double)offset)
#define jog_min_velocity(board,axis,rate) dcxvcmd(board,DBLCMDSZ,(axis<<8)+JV+DBLPARFLAG,(double)rate)
#define motion_limits_off(board,axis,select) dcxvcmd(board,LNGCMDSZ,(axis<<8)+LF,(long)select)
#define low_motion_limit(board,axis,position) dcxvcmd(board,DBLCMDSZ,(axis<<8)+LL+DBLPARFLAG,(double)position)
#define limit_mode(board,axis,mode) dcxvcmd(board,LNGCMDSZ,(axis<<8)+LM,(long)mode)
#define motion_limits_on(board,axis,select) dcxvcmd(board,LNGCMDSZ,(axis<<8)+LN,(long)select)
#define low_speed(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+LS+NOPARFLAG)
#define medium_speed(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+MS+NOPARFLAG)
#define set_min_velocity(board,axis,rate) dcxvcmd(board,DBLCMDSZ,(axis<<8)+MV+DBLPARFLAG,(double)rate)
#define set_module_output_mode(board,axis,select) dcxvcmd(board,LNGCMDSZ,(axis<<8)+OM,(long)select)
#define set_servo_output_phase(board,axis,select) dcxvcmd(board,LNGCMDSZ,(axis<<8)+PH,(long)select)
#define set_acceleration(board,axis,rate) dcxvcmd(board,DBLCMDSZ,(axis<<8)+SA+DBLPARFLAG,(double)rate)
#define set_derivative_gain(board,axis,gain) dcxvcmd(board,DBLCMDSZ,(axis<<8)+SD+DBLPARFLAG,(double)gain)
#define stop_on_error(board,axis,error) dcxvcmd(board,DBLCMDSZ,(axis<<8)+SE+DBLPARFLAG,(double)error)
#define step_full(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+SF+NOPARFLAG)
#define set_proportional_gain(board,axis,gain) dcxvcmd(board,DBLCMDSZ,(axis<<8)+SG+DBLPARFLAG,(double)gain)
#define step_half(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+SH+NOPARFLAG)
#define set_integral_gain(board,axis,gain) dcxvcmd(board,DBLCMDSZ,(axis<<8)+SI+DBLPARFLAG,(double)gain)
#define set_torque(board,axis,torque) dcxvcmd(board,DBLCMDSZ,(axis<<8)+SQ+DBLPARFLAG,(double)torque)
#define set_slave_ratio(board,axis,ratio) dcxvcmd(board,DBLCMDSZ,(axis<<8)+SS+DBLPARFLAG,(double)ratio)
#define set_velocity(board,axis,rate) dcxvcmd(board,DBLCMDSZ,(axis<<8)+SV+DBLPARFLAG,(double)rate)
#define set_user_output_constant(board,axis,value) dcxvcmd(board,DBLCMDSZ,(axis<<8)+UK+DBLPARFLAG,(double)value)
#define set_user_offset(board,axis,value) dcxvcmd(board,DBLCMDSZ,(axis<<8)+UO+DBLPARFLAG,(double)value)
#define set_user_rate(board,axis,value) dcxvcmd(board,DBLCMDSZ,(axis<<8)+UR+DBLPARFLAG,(double)value)
#define set_user_scale(board,axis,value) dcxvcmd(board,DBLCMDSZ,(axis<<8)+US+DBLPARFLAG,(double)value)
#define set_user_time(board,value) dcxvcmd(board,DBLCMDSZ,UT+DBLPARFLAG,(double)value)
#define set_user_zero(board,axis,value) dcxvcmd(board,DBLCMDSZ,(axis<<8)+UZ+DBLPARFLAG,(double)value)
#define vector_acceleration(board,axis,rate) dcxvcmd(board,DBLCMDSZ,(axis<<8)+VA+DBLPARFLAG,(double)rate)
#define vector_deceleration(board,axis,rate) dcxvcmd(board,DBLCMDSZ,(axis<<8)+VD+DBLPARFLAG,(double)rate)
#define set_velocity_gain(board,axis,gain) dcxvcmd(board,DBLCMDSZ,(axis<<8)+VG+DBLPARFLAG,(double)gain)
#define set_velocity_override(board,axis,value) dcxvcmd(board,DBLCMDSZ,(axis<<8)+VO+DBLPARFLAG,(double)value)
#define vector_velocity(board,axis,rate) dcxvcmd(board,DBLCMDSZ,(axis<<8)+VV+DBLPARFLAG,(double)rate)


/* Motion command macros */
#define abort(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+AB+NOPARFLAG)
#define aux_enc_find_index(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+AF+NOPARFLAG)
#define contour_mode(board,axis,caxis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+CM,(long)caxis)
#define find_edge(board,axis,position) dcxvcmd(board,DBLCMDSZ,(axis<<8)+FE+DBLPARFLAG,(double)position)
#define find_index(board,axis,position) dcxvcmd(board,DBLCMDSZ,(axis<<8)+FI+DBLPARFLAG,(double)position)
#define go_home(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+GH+NOPARFLAG)
#define gain_mode(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+GM+NOPARFLAG)
#define go(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+GO+NOPARFLAG)
#define home(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+HO+NOPARFLAG)
#define index_arm(board,axis,position) dcxvcmd(board,DBLCMDSZ,(axis<<8)+IA+DBLPARFLAG,(double)position)
#define learn_position(board,axis,index) dcxvcmd(board,LNGCMDSZ,(axis<<8)+LP,(long)index)
#define learn_target(board,axis,index) dcxvcmd(board,LNGCMDSZ,(axis<<8)+LT,(long)index)
#define move_absolute(board,axis,position) dcxvcmd(board,DBLCMDSZ,(axis<<8)+MA+DBLPARFLAG,(double)position)
#define motor_off(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+MF+NOPARFLAG)
#define motor_on(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+MN+NOPARFLAG)
#define move_to_point(board,axis,index) dcxvcmd(board,LNGCMDSZ,(axis<<8)+MP,(long)index)
#define move_relative(board,axis,distance) dcxvcmd(board,DBLCMDSZ,(axis<<8)+MR+DBLPARFLAG,(double)distance)
#define no_synchronization(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+NS+NOPARFLAG)
#define position_mode(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+PM+NOPARFLAG)
#define profile_s_curve(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+PS+NOPARFLAG)
#define profile_trapezoidal(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+PT+NOPARFLAG)
#define torque_mode(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+QM+NOPARFLAG)
#define set_master(board,axis,maxis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+SM,(long)maxis)
#define synchronization_on(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+SN+NOPARFLAG)
#define stop(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+ST+NOPARFLAG)
#define velocity_mode(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+VM+NOPARFLAG)


/* Reporting command macros */
#define tell_aux_enc_pos(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+AT+NOPARFLAG)
#define tell_aux_enc_idx(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+AZ+NOPARFLAG)
#define tell_analog(board,channel) dcxvcmd(board,LNGCMDSZ,TA,(long)channel)
#define tell_breakpoint(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TB,(long)DBLRPY)
#define tell_channel(board,channel) dcxvcmd(board,LNGCMDSZ,TC,(long)channel)
#define tell_derivative_gain(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TD,(long)DBLRPY)
#define tell_following_error(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TF,(long)DBLRPY)
#define tell_proportional_gain(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TG,(long)DBLRPY)
#define tell_integral_gain(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TI,(long)DBLRPY)
#define tell_velocity_constant(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TK,(long)DBLRPY)
#define tell_integration_limit(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TL,(long)DBLRPY)
#define tell_optimal(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TO,(long)DBLRPY)
#define tell_position(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TP,(long)DBLRPY)
#define tell_torque(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TQ,(long)DBLRPY)
#define tell_status(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+TS+NOPARFLAG)
#define tell_target(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TT,(long)DBLRPY)
#define tell_velocity(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TV,(long)DBLRPY)
#define tell_contouring_count(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+TX+NOPARFLAG)
#define tell_index(board,axis) dcxvcmd(board,LNGCMDSZ,(axis<<8)+TZ,(long)DBLRPY)


/* Register command macros */
#define acculator_load_long(board,value) dcxvcmd(board,LNGCMDSZ,AL,(long)value)
#define acculator_load_float(board,value) dcxvcmd(board,FLTCMDSZ,AL+FLTPARFLAG,(float)value)
#define acculator_load_double(board,value) dcxvcmd(board,DBLCMDSZ,AL+DBLPARFLAG,(double)value)
#define copy_acc_to_reg(board,register) dcxvcmd(board,LNGCMDSZ,AR,(long)register)
#define read_byte(board,axis,location) dcxvcmd(board,LNGCMDSZ,(axis<<8)+RB,(long)location)
#define read_double(board,axis,location) dcxvcmd(board,LNGCMDSZ,(axis<<8)+RD,(long)location)
#define read_long(board,axis,location) dcxvcmd(board,LNGCMDSZ,(axis<<8)+RL,(long)location)
#define read_float(board,axis,location) dcxvcmd(board,LNGCMDSZ,(axis<<8)+RV,(long)location)
#define read_word(board,axis,location) dcxvcmd(board,LNGCMDSZ,(axis<<8)+RW,(long)location)
#define copy_reg_to_acc(board,register) dcxvcmd(board,LNGCMDSZ,RA,(long)register)
#define tell_register(board,register) dcxvcmd(board,LNGCMDSZ,TR,(long)register)
#define write_byte(board,axis,location) dcxvcmd(board,LNGCMDSZ,(axis<<8)+WB,(long)location)
#define write_double(board,axis,location) dcxvcmd(board,LNGCMDSZ,(axis<<8)+WD,(long)location)
#define write_long(board,axis,location) dcxvcmd(board,LNGCMDSZ,(axis<<8)+WL,(long)location)
#define write_float(board,axis,location) dcxvcmd(board,LNGCMDSZ,(axis<<8)+WV,(long)location)
#define write_word(board,axis,location) dcxvcmd(board,LNGCMDSZ,(axis<<8)+WW,(long)location)


/* Macro command macros */
#define generate_task(board,macro) dcxvcmd(board,LNGCMDSZ,GT,(long)macro)
#define macro_call(board,macro) dcxvcmd(board,LNGCMDSZ,MC,(long)macro)
#define macro_jump(board,macro) dcxvcmd(board,LNGCMDSZ,MJ,(long)macro)


/* Sequence command macros */
#define interrupt_on_position(board,axis,position) dcxvcmd(board,DBLCMDSZ,(axis<<8)+IP+DBLPARFLAG,(double)position)
#define interrupt_on_relative(board,axis,distance) dcxvcmd(board,DBLCMDSZ,(axis<<8)+IR+DBLPARFLAG,(double)distance)
#define wait(board,period) dcxvcmd(board,DBLCMDSZ,WA+DBLPARFLAG,(double)period)
#define wait_for_edge(board,axis,level) dcxvcmd(board,LNGCMDSZ,(axis<<8)+WE,(long)level)
#define wait_for_channel_off(board,channel) dcxvcmd(board,LNGCMDSZ,WF,(long)channel)
#define wait_for_index(board,axis) dcxvcmd(board,CMDSZ,(axis<<8)+WI)
#define wait_for_channel_on(board,channel) dcxvcmd(board,LNGCMDSZ,WN,(long)channel)
#define wait_for_position(board,axis,position) dcxvcmd(board,DBLCMDSZ,(axis<<8)+WP+DBLPARFLAG,(double)position)
#define wait_for_relative(board,axis,distance) dcxvcmd(board,DBLCMDSZ,(axis<<8)+WR+DBLPARFLAG,(double)distance)
#define wait_for_stop(board,axis,period) dcxvcmd(board,DBLCMDSZ,(axis<<8)+WS+DBLPARFLAG,(double)period)
#define wait_for_target(board,axis,period) dcxvcmd(board,DBLCMDSZ,(axis<<8)+WT+DBLPARFLAG,(double)period)


/* Macro for reading replies to commands */
#define get_reply(board,buffer) dcxrpy(board,sizeof(buffer),(int far *)buffer)


/* Macros for issuing reporting commands to board and returning values */
#define get_aux_enc_pos(board,axis) ((tell_aux_enc_pos(board,axis), get_reply(board,lngrpybuf)), lngrpybuf[0].val)
#define get_aux_enc_idx(board,axis) ((tell_aux_enc_pos(board,axis), get_reply(board,lngrpybuf)), lngrpybuf[0].val)
#define get_analog(board,channel) ((tell_analog(board,channel), get_reply(board,lngrpybuf)), lngrpybuf[0].val)
#define get_breakpoint(board,axis) ((tell_breakpoint(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_channel(board,channel) ((tell_channel(board,channel), get_reply(board,lngrpybuf)), lngrpybuf[0].val)
#define get_derivative_gain(board,axis) ((tell_derivative_gain(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_following_error(board,axis) ((tell_following_error(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_proportional_gain(board,axis) ((tell_proportional_gain(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_integral_gain(board,axis) ((tell_integral_gain(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_velocity_constant(board,axis) ((tell_velocity_constant(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_integration_limit(board,axis) ((tell_integration_limit(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_optimal(board,axis) ((tell_optimal(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_position(board,axis) ((tell_position(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_register_long(board,register) ((tell_register(board,register), get_reply(board,lngrpybuf)), lngrpybuf[0].val)
#define get_register_float(board,register) ((tell_register(board,register), get_reply(board,fltrpybuf)), fltrpybuf[0].val)
#define get_register_double(board,register) ((tell_register(board,register), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_torque(board,axis) ((tell_torque(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_status(board,axis) ((tell_status(board,axis), get_reply(board,lngrpybuf)), lngrpybuf[0].val)
#define get_target(board,axis) ((tell_target(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_velocity(board,axis) ((tell_velocity(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)
#define get_contouring_count(board,axis) ((tell_contouring_count(board,axis), get_reply(board,lngrpybuf)), lngrpybuf[0].val)
#define get_index(board,axis) ((tell_index(board,axis), get_reply(board,dblrpybuf)), dblrpybuf[0].val)


/* End of DCX2CMAC.H */



