{
	Copyright (c) Precision Micro Control Corp. 1994
	All rights reserved
}

program pasdemo;

{
	PASDEMO.PAS - DCX-AT200 Pascal Interface Demo Program
	Revision: 1.0a
	Date: 9/6/94
	Programmer: Bruce Robinson

	Abstract: This program demonstates the use of the DCX-AT200 Pascal
	          interface.

	To build this program under Turbo Pascal version 6.0, use the following
	DOS command line:
		TPC /m PASDEMO

	Revision History:
	1.0a	9/6/94   Initial release

	Tab stops = 3
}

uses DCX2PIFC;			{ This specifies the DCX-AT200 Pascal interface library
								compiled as a unit (see the file DCX2PIFC.PAS). }

var
	board,axis:integer;
	loop:integer;

begin
	writeln;
	writeln('DCX Pascal Interface Demo Program    Rev. 1.0a');
	writeln('Precision Micro Control Corp.');
	writeln;
   writeln('Servo parameters should be set for axis 1 prior to');
   writeln(' running this program');
	writeln;
   writeln('Press ENTER if you wish to continue demo, <CNTRL> C to quit');
   readln;

   board := 0;			{ DCX board number, must match rotary switch on DCX }
   axis := 1;

	motor_on(board,axis);	{ Issue Motor oN command to DCX board }

   { Move servo axis a relative distance, wait for it to stop, then
     display its true and desired position. Repeat move 9 times. }
	writeln('         Pos.     Opt.');
   for loop := 1 to 10 do
	begin
		move_relative(board,axis,1000.0);	{ Third parameter is distance }
      wait_for_stop(board,axis,1.0);		{ Third parameter is period }

									{ Display desired and true position from DCX }
		writeln('Axis ',axis,': ',get_position(board,axis):6,' , ',
									get_optimal(board,axis):6);
	end;

end.


